// Written by TeTeT for F/A-18


js_jc_fa18_fnc_requestTanker = {
	params ["_plane"];

	_plane vehicleChat "Requesting tanker";

	private _size = worldSize + 1000;
	private _alt = 2000;

	private _wp1coord = [_size, _size, _alt];
	private _wp2coord = [-1000, _size, _alt];
	private _wp3coord = [-1000, _size + 1000, _alt];
	private _wp4coord = [_size, _size + 1000, _alt];
	private _areaCoord = [worldSize / 2, _size + 500, _alt];

	private _wp1marker = createMarker ["WP1", _wp1coord];
	_wp1marker setMarkerText "Tanker WP1";
	private _wp2marker = createMarker ["WP2", _wp2coord];
	_wp2marker setMarkerText "Tanker WP2";
	private _wp3marker = createMarker ["WP3", _wp3coord];
	_wp3marker setMarkerText "Tanker WP3";
	private _wp4marker = createMarker ["WP4", _wp4coord];
	_wp4marker setMarkerText "Tanker WP4";

	{
		_x setMarkerType "loc_Fuelstation";
		_x setMarkerColor "ColorBlue";
	} forEach [_wp1marker, _wp2marker, _wp3marker, _wp4marker];

	private _tankerAreaMarker = createMarker ["tankerArea", _areaCoord];
	_tankerAreaMarker setMarkerShape "RECTANGLE";
	_tankerAreaMarker setMarkerColor "ColorBlue";
	_tankerAreaMarker setMarkerSize [(_size + 2000) / 2, 1000];

	private _tanker = createVehicle ["JS_JC_FA18F", _areaCoord, 
		[_wp1marker, _wp2marker, _wp3marker, _wp4marker], 0, "FLY"];
	js_jc_ttt_tanker = _tanker;
	private _tankerCrew = createVehicleCrew _tanker;
	private _wp = _tankerCrew addWaypoint [_wp1coord, 100];
	_wp setWaypointSpeed "LIMITED";
	_wp = _tankerCrew addWaypoint [_wp2coord, 100];
	_wp setWaypointSpeed "LIMITED";
	_wp = _tankerCrew addWaypoint [_wp3coord, 100];
	_wp setWaypointSpeed "LIMITED";
	_wp = _tankerCrew addWaypoint [_wp4coord, 100];
	_wp setWaypointSpeed "LIMITED";
	_wp setWaypointType "CYCLE";
	
	_tanker flyInHeight 100;
	_tanker flyInHeightASL [_alt, _alt, _alt];
	_tanker setBehaviour "CARELESS";
	{
		_tanker setPylonLoadOut [_x, "js_m_fa18_wing_tank_x1", true];
	} forEach ["pylon5", "pylon6", "pylon7", "pylon8"];
	_tanker setPylonLoadOut ["pylon11", "js_m_fa18_buddypod_x1", true];

	[_tanker] spawn {
		params ["_tanker"];

		private _mrkr = createMarker ["tanker", position _tanker];
		_mrkr setMarkerType "b_plane";
		_mrkr setMarkerColor "ColorPink";
		_mrkr setMarkerText "Tanker";
		while {alive _tanker} do {
			_mrkr setMarkerPos (position _tanker);
			// this is a hack - full tanks all the time
			_tanker setFuel 1;
			_tanker animate ["auxtank_switch", 1];
			sleep 0.1;
		};
		_mrkr setMarkerColor "ColorBlack";
		deleteMarker _mrkr;
		js_jc_ttt_tanker = nil;
	};
	// setup comms
	[_plane, _tanker] spawn {
		params ["_plane", "_tanker"];

		private _radio = radioChannelCreate [ [0.416, 0.051, 0.678, 1], "Purple Crown", "Purple Crown", (crew _plane) + (crew _tanker) , [] ];
		sleep 1;
		(driver _tanker) customChat [_radio, "Tanker available for you"];
		(driver _tanker) customChat [_radio, "Hold on, directions coming"];
		sleep 5;
		private _direction = floor (_plane getDir _tanker);
		private _distance = round ( (_plane distance2d _tanker) / 1000 );
		(driver _tanker) customChat [_radio, format["Fly %1 degrees for %2 klicks", _direction, _distance]];
	};
};


[] spawn {
	private _plane = f18;
	// private _requestTankerId = [_plane, "Support_Request_Tanker"] call BIS_fnc_addCommMenuItem;
	_plane addAction [
		"Request Tanker",
		"_this spawn js_jc_fa18_fnc_requestTanker",
		nil,
		5,
		false,
		true,
		"",
		"isNil 'js_jc_ttt_tanker'"
	];
};
